import greenfoot.*;
/**
 * Write a description of class Boss1Attack here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Boss1Attack  extends AttackBehavior 
{
    public Boss1Attack()
    {
        super();
    }

    public void fireBullet(Boss1 boss, Player p, Boss1Bullet bullet, int dir)
    {
        double angle = findAngle(boss.getExactX(), boss.getExactY(), p.getExactX(), p.getExactY());
        if(dir == 0){
            angle = angle + Math.PI/6.0;
        }else if(dir == 1){
            angle = angle - Math.PI/6.0;
        }

        double dx = Math.cos(angle);                        
        double dy = Math.sin(angle); 
        bullet.setDx(dx);
        bullet.setDy(dy);
        bullet.setExactX(boss.getExactX());
        bullet.setExactY(boss.getExactY());
        bullet.setLocation((int)Math.round(bullet.getExactX()), (int)Math.round(bullet.getExactY()));
        bullet.setActive(true);
        bullet.getImage().setTransparency(255);
    }

    private double findAngle(double x1, double y1, double x2, double y2)
    {
        double dx = x2-x1;
        double dy = y2-y1;
        if(dy==0){
            if(dx>0){
                return 0;
            }else{
                return Math.PI;
            }
        }

        if(dx==0){
            if(dy>0){
                return Math.PI/2.0;
            }else{
                return 3.0*Math.PI/2.0;
            }
        }

        double angle = Math.atan(dy/dx);
        if(dx>0 && dy>0){           //quadrant 1
            return angle;
        }else if(dx<0 && dy>0){      //quadrant 2
            return (Math.PI+angle);
        }else if(dx<0 && dy<0){     //quadrant 3
            return (angle+Math.PI);
        }else if(dx>0 && dy<0){     //quadrant 4
            return (2*Math.PI+angle);
        }

        return 0;
    }
}
