import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Boss1Bullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Boss1Bullet  extends Bullet
{
    private static final GreenfootImage[] donut = {
                                                new GreenfootImage("images/enemy/boss1/bossAttack1.png"),
                                                new GreenfootImage("images/enemy/boss1/bossAttack2.png")
                                                };
    private int donutIndex;
    
    public Boss1Bullet()
    {
        super(0,0);
        donutIndex = 0;
        active = false;
    }

    public void updateImage()
    {
        setImage(new GreenfootImage(donut[donutIndex]));
        donutIndex = (donutIndex+1)%donut.length;
    }

    public void reset(){
        active = false;
        getImage().setTransparency(0);
    }
    
    /**
     * Act - do whatever the Boss1Bullet wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer+1)%10000;
        if(active){

            if(actTimer%12==0){
                updateImage();
            }

            setExactX(getExactX()+getDx());
            setExactY(getExactY()+getDy());

            if(getExactX() >= getWorld().getWidth() || getExactX() < 0){
                setActive(false);
                getImage().setTransparency(0);
                return;
            }
            if(getExactY() >= getWorld().getHeight() || getExactY() < 0){
                setActive(false);
                getImage().setTransparency(0);
                return;
            }
            setLocation( (int)Math.round(getExactX()), (int)Math.round(getExactY()));
        }
    }    


}
