import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy  extends LiveObject
{
    protected int startX;
    protected int startY;
    protected boolean invert;
 
    public Enemy(int x, int y)
    {
        super(x,y);
        active = false;    
    }

    public boolean getInvert(){
        return invert;    
    }
    public void setInvert(boolean b){
        invert = b;    
    }

    public void reset(){}   //overwrite in subclass to implement
    
    private void chooseExplode(){
        if(getWorld() == null)
            return;
        if(this instanceof Boss1){
            
        }else if(this instanceof Blocker){
            multiExplode();
        }else{
            singleExplode();
        }
    }
    
    private void multiExplode(){
        int dist = 20;
        Regular r1 = new Regular((int)Math.round(getExactX()),(int)Math.round(getExactY()),0);
        Regular r2 = new Regular((int)Math.round(getExactX()+dist),(int)Math.round(getExactY()+dist),5);
        Regular r3 = new Regular((int)Math.round(getExactX()-dist),(int)Math.round(getExactY()),20);
        Regular r4 = new Regular((int)Math.round(getExactX()-dist),(int)Math.round(getExactY()-dist),35);
        Regular r5 = new Regular((int)Math.round(getExactX()+dist),(int)Math.round(getExactY()),50);
        Regular r6 = new Regular((int)Math.round(getExactX()-dist),(int)Math.round(getExactY()-dist),55);
        
        getWorld().addObject(r1,getX(),getY());
        getWorld().addObject(r2,getX()+dist,getY()+dist);        
        getWorld().addObject(r3,getX()-dist,getY());
        getWorld().addObject(r4,getX()-dist,getY()-dist);        
        getWorld().addObject(r5,getX()+dist,getY());
        getWorld().addObject(r6,getX()-dist,getY()-dist);
    }
    
    private void singleExplode(){
            getWorld().addObject(new Regular((int)Math.round(getExactX()),(int)Math.round(getExactY()),0),getX(),getY());    
    }
    
    public void kill(){
        if(this instanceof Boss1){
            ((Boss1)this).removeBullets();
            ((MusicController)getWorld().getObjects(MusicController.class).get(0)).stopMusic();
            ((MusicController)getWorld().getObjects(MusicController.class).get(0)).playBossDeath();
        }else if (this instanceof Blocker){
            ((MusicController)getWorld().getObjects(MusicController.class).get(0)).playSpecialEnemyDeath();
        }else{
            ((MusicController)getWorld().getObjects(MusicController.class).get(0)).playEnemyDeath();
        }
        
        if(this instanceof Shooter){
            ((Shooter)this).getBullet().setParentDead(true);
        }

        chooseExplode();
        getWorld().removeObject(this);
    }
}
