import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
/**
 * Write a description of class GameObject here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GameObject  extends Actor
{
    protected Point currentPoint;   
    protected Point previousPoint;
    protected boolean active;
    protected boolean updatePosition;
    protected double dx;
    protected double dy;
    protected int health;
    protected int actTimer;
    protected double baseDy;
    
    public GameObject(int startX, int startY)
    {
            previousPoint = new Point(startX, startY);        
            currentPoint = new Point(startX, startY);
            updatePosition = true;
            dx = 0.0;
            dy = 0.0;
            baseDy = 0.0;
            health = 1;
            actTimer = 1;
    }
    
    public void addedToWorld(World world){
        world.addObject(this, (int)currentPoint.getX(), (int)currentPoint.getY());    
    }
    public boolean getActive(){
        return active;    
    }
    public void setActive(boolean b){
        if(active == false && b==true){
            actTimer = 1;    
        }
        active = b;    
        if(active==true && getImage().getTransparency()!=255){
            getImage().setTransparency(255);
            //actTimer = 0;
        }
        if(active==false && getImage().getTransparency()!=0){
            getImage().setTransparency(0);        
        }
    }
    public double getDx(){
        return dx;    
    }
    public double getDy(){
        return dy;    
    }
    public void setDx(double d){
        dx = d;    
    }
    public void setDy(double d){
        dy = d;    
    }    
    public void resetDy(){
        dy = baseDy;    
    }
    public boolean getUpdatePosition(){
        return updatePosition;
    }
    public void setUpdatePosition(boolean b){
        updatePosition = b;
    }
    public void fixX(double d){
      //d = borderFixX(d);        
      currentPoint.setX(d);  
    }
    public void fixY(double d){
      //d = borderFixY(d);        
      currentPoint.setY(d);
    }
    public void setExactX(double d){
        //d = borderFixX(d);
        previousPoint.setX(currentPoint.getX());
        currentPoint.setX(d);
    }
    public void setExactY(double d){
        //d = borderFixY(d);        
        previousPoint.setY(currentPoint.getY());
        currentPoint.setY(d);        
    }
    public double getExactX(){
        return currentPoint.getX();    
    }
    public double getExactY(){
        return currentPoint.getY();    
    }
    public double getOldX(){
        return previousPoint.getX();        
    }
    public double getOldY(){
        return previousPoint.getY();        
    }
}
