import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level1 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level1  extends Level
{
    private static final Enemy[] section0 = {
                                new Walker(440, 120, false), new Walker(580, 150, false), new Walker(600, 43, true), new Walker(705, 182, false),
                                new Walker(750, 150, false), new Walker(795, 88, false), new Walker(870, 43, true), new Walker(965, 118, false),
                                new Walker(1090, 150, false), new Walker(1145, 182, false), new Walker(1460, 88, false), new Walker(1478, 135, false),
                                new Walker(1864, 117, false), new Shooter(1834,81,false),
                                new Spinner(1259, 74, false), new Spinner(1341,168,true)
                            };
    private static final Powerup[] section0P = {};                                
                            
    private static final Enemy[] section1 = {
                                new Walker(800,184,false),      new Walker(1180,41,true),   new Walker(1940, 73, true), new Walker(1940,168,false), 
                                new Blocker(1768,169),          new Shooter(326,130,false), new Shooter(517,97,false),  new Shooter(676,66,false),
                                new Shooter(713, 129, false),   new Shooter(836,144,false), new Shooter(906,175, true),
                                new Shooter(963,82, false),     new Shooter(1224,160,true), new Shooter(1316,96,false)
                            };             
    private static final Powerup[] section1P = {
                            new Armor(300,65), new FireballPower(355,65), new GunPower(1903,34)
    };
                            
    private static final Enemy[] section2 = {
                            new Boss1(128,76), new Boss1Overlay(128,73)
                            };        
    private static final Powerup[] section2P = {};                            
                            
    public Level1()
    {
        section = new Screen[3];

        section[0] = new Screen(new GreenfootImage("images/level/level1/v1.png"),new GreenfootImage("images/level/level1/v1Mask.png"));
        section[0].setEnemies(section0);
        section[0].setPowerups(section0P);        
        section[0].setPoint(new Point(25,150));                        
        

        section[1] = new Screen(new GreenfootImage("images/level/level1/v2.png"),new GreenfootImage("images/level/level1/v2Mask.png"));        
        section[1].setEnemies(section1);
        section[1].setPowerups(section1P);
        section[1].setPoint(new Point(23,86));


        section[2] = new Screen(new GreenfootImage("images/level/level1/v3.png"),new GreenfootImage("images/level/level1/v3Mask.png"));                
        section[2].setEnemies(section2);
        section[2].setPowerups(section2P);        
        section[2].setPoint(new Point(96,183));
    }
    
    /**
     * Act - do whatever the Level1 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
