import greenfoot.*;
/**
 * Write a description of class MusicController here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MusicController extends Actor
{
    private static GreenfootSound level1Loop;
    private static GreenfootSound boss;  
    private static GreenfootSound gameOver;
    private static GreenfootSound explode;
    private static GreenfootSound pause;
    private static GreenfootSound getPowerup;
    private static GreenfootSound hitEnemy;  
    private static GreenfootSound enemyDeath;
    private static GreenfootSound specialEnemyDeath;    
    private static GreenfootSound bossDeath;    
    private boolean musicStart;

    /**
     * Constructor for objects of class MusicController
     */
    public MusicController()
    {
        musicStart = false;
        try{level1Loop = new GreenfootSound("sounds/level1Loop.mp3");}catch(Exception e){}
        try{boss = new GreenfootSound("sounds/boss.mp3");}catch(Exception e){} 
        try{gameOver = new GreenfootSound("sounds/gameover.mp3");}catch(Exception e){}
        try{explode = new GreenfootSound("sounds/explode.mp3");}catch(Exception e){}
        try{pause = new GreenfootSound("sounds/pause.mp3");}catch(Exception e){}        
        try{getPowerup = new GreenfootSound("sounds/powerup.mp3");}catch(Exception e){} 
        try{hitEnemy = new GreenfootSound("sounds/enemyDamage.mp3");}catch(Exception e){}   
        try{enemyDeath = new GreenfootSound("sounds/enemyDeath.mp3");}catch(Exception e){}
        try{bossDeath = new GreenfootSound("sounds/bossDeath.mp3");}catch(Exception e){}    
        try{specialEnemyDeath = new GreenfootSound("sounds/bigExplode.mp3");}catch(Exception e){}            
    }

    public boolean getMusicStart()
    {
        return musicStart;
    }

    public void playHitEnemy(){
        try{hitEnemy.play();}catch(Exception e){}
    }
    public void playEnemyDeath(){
        try{enemyDeath.play();}catch(Exception e){}
    }
    public void playSpecialEnemyDeath(){
        try{specialEnemyDeath.play();}catch(Exception e){}
    }    
    public void playBossDeath(){
        try{bossDeath.play();}catch(Exception e){}
    }    
    public void playGameOver()
    {
        if(gameOver != null && gameOver.isPlaying())
            return;
        stopMusic();
        try{gameOver.playLoop();}catch(Exception e){}
    }
    public void playPause(){
        try{pause.play();}catch(Exception e){}
    }
    public void playGetPowerup(){
        try{getPowerup.play();}catch(Exception e){}        
    }
    public void playExplode(){
        stopMusic();
        try{explode.play();}catch(Exception e){}
    }
    
    public void setMusicStart(boolean x)
    {
        musicStart = x;
    }


    

    
    public boolean isPausePlaying(){
        if(pause == null){
            return false;
        }
        return pause.isPlaying();    
    }
    public void stopExplode(){
        explode.stop();
    }
    public boolean isExplodePlaying(){
        if(explode == null){
            return false;    
        }
        return explode.isPlaying();
    }

    public void music(WorldStats stats)
    {
        if(musicStart == false && !isPausePlaying()){
            stopMusic();
            switch(stats.getLevelNumber()){
                case 1:
                    if(stats.getSection() == stats.getCurrentLevel().numSections()-1){
                        try{boss.playLoop();}catch(Exception e){}
                    }else{
                        try{level1Loop.playLoop();}catch(Exception e){}
                    }
                    musicStart = true;
                    break;
                    
                default:
                        try{boss.playLoop();}catch(Exception e){}                
                    break;
                }
        }
    }

    public void stopMusic(){
        try{level1Loop.stop();}catch(Exception e){}
        try{boss.stop();}catch(Exception e){}
        try{gameOver.stop();}catch(Exception e){}

    }
}
