import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class WorldStats here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WorldStats  extends Actor
{
    private Level currentLevel;         //current level in game
    private boolean flip;               //determines whether enemies should be flipped or not
    private int section;                //current section number of current level
    private int level;                  //current level number
    private boolean nextSectionFlag;     //flag to get next section. is consumed when called
    private boolean nextLevelFlag;       //flag to get next level. is consumed when called
    private boolean deathFlag;          //flag to restart at current section. is consumed when called
    private boolean gameOverFlag;       //flag to go to game over screen
    private boolean gameStartFlag;      //flag for the start of the game
    
    private Level1 level1 = new Level1();
    
    public WorldStats(){
        currentLevel = level1;
        level1.getImage().setTransparency(0);                
        flip = false;
        level = 1;
        section = 0;
        nextSectionFlag = false;
        nextLevelFlag = false;
        deathFlag = false;
        gameOverFlag = false;
        gameStartFlag = false;
    }
    
    public void addedToWorld(World world){
        world.addObject(currentLevel,0,0);
        currentLevel.getImage().setTransparency(0);
    }
    
    public void reset(){
        setCurrentLevel(1);       
        flip = false;
        level = 1;
        section = 0;
        nextSectionFlag = false;
        nextLevelFlag = false;
        deathFlag = false;
        gameOverFlag = false;
        gameStartFlag = false;        
    }
    
    public Enemy[] getCurrentEnemies(){
        return currentLevel.getSection(section).getEnemies();
    }
    public Powerup[] getCurrentPowerups(){
        return currentLevel.getSection(section).getPowerups();
    }    
    public void setCurrentLevel(int i){
        List l = getWorld().getObjects(Level.class);        
        switch(i){
            case 1:
                getWorld().removeObjects(l);
                currentLevel = new Level1();
                getWorld().addObject(currentLevel,0,0);
                currentLevel.getImage().setTransparency(0);    
                break;
            
            default:
                getWorld().removeObjects(l);
                currentLevel = new Level1();
                getWorld().addObject(currentLevel,0,0);
                currentLevel.getImage().setTransparency(0);
                break;
        }
    }
    public Level getCurrentLevel(){
        return currentLevel;    
    }
    public int getSection(){
        return section;    
    }
    public void setSection(int i){
        section = i;    
    }
    public int getLevelNumber(){
        return level;    
    }
    public void setLevelNumber(int i){
        level = i;    
    }
    public boolean getFlip(){
        return flip;
    }
    public void setFlip(boolean b){
        flip = b; 
    }
    public boolean getNextSectionFlag(){
        if(nextSectionFlag == true){
            nextSectionFlag = false;
            return true;
        }else{
            return false;    
        }
    }
    public void setNextSectionFlag(boolean b){
        nextSectionFlag = b;    
    }
    public boolean nextLevelFlag(){
        if(nextLevelFlag == true){
            nextLevelFlag = false;
            return true;
        }else{
            return false;    
        }
    }
    public void setNextLevelFlag(boolean b){
        nextLevelFlag = b;    
    }
    public boolean getDeathFlag(){
        return deathFlag;
    }
    public void setDeathFlag(boolean b){
        deathFlag = b;    
    }
    public boolean getGameOverFlag(){
        return gameOverFlag;
    }
    public void setGameOverFlag(boolean b){
        gameOverFlag = b;    
    }
    public boolean getGameStartFlag(){
            return gameStartFlag;
    }
    public void setGameStartFlag(boolean b){
        gameStartFlag = b;    
    }
}
