import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Write a description of class Level here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level  extends Actor
{
    protected Screen[] section;
    protected double xScroll;
    protected double yScroll;

    public Level()
    {
          xScroll = 0;
          yScroll = 0;
    }
    public int numSections(){
        if(section == null){
            return 0;    
        }else{
            return section.length;    
        }
    }
    public void setXScroll(double d){
        xScroll = d;    
    }
    public void setYScroll(double d){
        yScroll = d;    
    }    
    public double getXScroll(){
        return xScroll;    
    }
    public double getYScroll(){
        return yScroll;    
    }    
    public Screen getSection(int index){
        return section[index];    
    }
    
    public GreenfootImage getCurrentImage(int index)
    {
        if(section[index] != null){
            return section[index].getVisible();
        }else{
            return (new GreenfootImage("images/level/level1/v1.png"));    
        }
    }    
    
    public GreenfootImage getCurrentLogicalImage(int index)
    {
        if(section[index] != null){
            return section[index].getLogical();
        }else{
            return (new GreenfootImage("images/level/level1/v1Mask.png"));    
        }
    }      
}
