import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Regular here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Regular  extends Explosion
{
    private static final GreenfootImage[] explodeImage = {
                new GreenfootImage("images/explode/basic/explode0.png"),        
                new GreenfootImage("images/explode/basic/explode1.png"),
                new GreenfootImage("images/explode/basic/explode2.png"),                
                new GreenfootImage("images/explode/basic/explode3.png"),                
                new GreenfootImage("images/explode/basic/explode4.png"),                
                new GreenfootImage("images/explode/basic/explode5.png"),                
                new GreenfootImage("images/explode/basic/explode6.png"),                
                new GreenfootImage("images/explode/basic/explode7.png"),                
                new GreenfootImage("images/explode/basic/explode8.png"),                
                new GreenfootImage("images/explode/basic/explode9.png")                
    };
    private int imageIndex;
    private static final int imageUpdateDelay = 2;
    public Regular(int x, int y, int d){
        super(x,y);    
        imageIndex = 0;
        actTimer = 1;
        active = false;
        delay = d;
        setImage(new GreenfootImage(explodeImage[0]));
    }
    
    public void addedToWorld(World world){
        active = true;    
        actTimer = -1*delay;
    }
    
    public void act() 
    {
        if(active){
            actTimer = (actTimer+1)%100000;
            if(actTimer > 0 && actTimer%imageUpdateDelay==0){
                setImage(new GreenfootImage(explodeImage[imageIndex]));    
                imageIndex++;
                if(imageIndex >= explodeImage.length){
                    getWorld().removeObject(this);    
                }
            }
        }
    }    
}
